<?php
//查询处理
require ("./whoishub.php");
$domain = $_GET['domain'];
if (substr($domain, 0, 1) == ".") {
    $domain = preg_replace('/^./', '', $domain);
} else if (substr($domain, -1) == ".") {
    $domain = preg_replace('#.$#i', '', $domain);
}
if (!empty($domain)) {
    $domain = preg_replace('/ /i', '', $domain);
    $domain = preg_replace('/^http:\/\//i', '', $domain);
    $domain = preg_replace('/^https:\/\//i', '', $domain);
    $domain = strtolower(trim($domain));
    $domain = explode('/', $domain);
    $domain = trim($domain[0]);
    
    /* PHP>=7.2 使用该配置前，请确保服务器php环境已安装intl扩展。*/
    
    $domain = idn_to_ascii($domain, IDNA_NONTRANSITIONAL_TO_ASCII, INTL_IDNA_VARIANT_UTS46);
    $dedomain = idn_to_utf8($domain, IDNA_NONTRANSITIONAL_TO_UNICODE, INTL_IDNA_VARIANT_UTS46);
    
    /* 5.3>=PHP<7.2 使用该配置前，请确保服务器php环境已安装intl扩展。*/
    
    //$domain = idn_to_ascii($domain, IDNA_NONTRANSITIONAL_TO_ASCII, INTL_IDNA_VARIANT_2003);
    //$dedomain = idn_to_utf8($domain, IDNA_NONTRANSITIONAL_TO_UNICODE, INTL_IDNA_VARIANT_2003);
}
if (substr_count($domain, ".") == 2) {
    $dotpos = strpos($domain, ".");
    $domtld = strtolower(substr($domain, $dotpos + 1));
    $whoisserver = $whoisservers[$domtld];
    if (!$whoisserver) {
        if (strpos($domain, "www") === false) {
        } else {
            $domain = preg_replace('/^www\./i', '', $domain);
        }
    }
}

function LookupDomain($domain) {
    global $whoisservers;
    $whoisserver = "";
    $dotpos = strpos($domain, ".");
    $domtld = strtolower(substr($domain, $dotpos + 1));
    $whoisserver = $whoisservers[$domtld];
    if (!$whoisserver) {
        $result = QueryWhoisServer("whois.iana.org", $domain);
        return "<b>FAILED</b>: Unable to match the WHOIS Server of <b>" . $domain . "</b>\n\n<b>Another data from whois.iana.org ↓↓↓</b>\n\n" . $result;
    }
    //if($whoisserver == "whois.verisign-grs.com") $domain = "=".$domain; // whois.verisign-grs.com requires the equals sign ("=") or it returns any result containing the searched string.
    $result = QueryWhoisServer($whoisserver, $domain);
    if (!$result) {
        return "<b>FAILED</b>: No results retrieved " . $domain . " !";
    }
    preg_match("/Whois Server: (.*)/", $result, $matches);
    $secondary = $matches[1];
    if ($secondary) {
        $result = QueryWhoisServer($secondary, $domain);
    }
    return "<b>SUCCESS</b>: WHOIS Server Matched\n\n<b>Searched from " . $whoisserver . " ↓↓↓</b>\n\n" . $result;
}
function QueryWhoisServer($whoisserver, $domain) {
    $port = 43;
    $timeout = 10;
    $fp = @fsockopen($whoisserver, $port, $errno, $errstr, $timeout) or die("<pre>\nSocket Error " . $errno . " - " . $errstr);
    fputs($fp, $domain . "\r\n");
    $out = "";
    while (!feof($fp)) {
        $out.= fgets($fp);
    }
    fclose($fp);
    return $out;
}
?>